Fix exception in Redmine.pm when authenticating anonymous users
Description

The is_member function in Redmine.pm searches users which have the required permissions to access the repository. The used

SQL however doesn't restrict the returned data to actual users but includes groups as well. This results in the following exception:

[perl:error] [pid 29442] [client 127.0.0.1:49599] Use of uninitialized value $salt in concatenatio

n (.) or string at /usr/share/perl5/Apache/Redmine.pm line 483.\n

 If the user doesn't provide a login here, it defaults to an empty string in the query. Unfortunately, an empty login applies to both the

Anonymous user as well as all groups. Thus, if there are any groups, this can result in multiple lines being returned as a SQL result

set that do not belong to actual users.

The attached patch by Planio fixes the SQL query so that only actual users are queried here.

Associated revisions

Revision 14892 - 2015-11-28 06:59 - Jean-Philippe Lang

Only select actual users from the database in Redmine.pm (#21312).

Patch by Holger Just.

Revision 14917 - 2015-12-04 13:49 - Jean-Philippe Lang

Merged r14892 (#21312).

Revision 14918 - 2015-12-04 13:49 - Jean-Philippe Lang

Merged r14892 (#21312).

Revision 14919 - 2015-12-04 13:49 - Jean-Philippe Lang

Merged r14892 (#21312).

History

#1 - 2015-11-25 03:14 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#2 - 2015-11-28 07:00 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next minor release to 2.6.9

#3 - 2015-12-04 13:49 - Jean-Philippe Lang

- Status changed from Resolved to Closed
